#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <libxode.h>

#include <unistd.h>		/* sleep */

#include "all.h"

#include "config.h"
#include "jabber.h"
#include "tlen.h"
#include "jid.h"
#include "encoding.h"

#include "jabber.h"

int jabber_gniazdo;
int jabber_server;

struct sockaddr_in server_addr;
socklen_t server_addrlen;

struct servent *sp;
struct hostent *hp;


/* Buffor dla polaczenia */
char *js_buf = NULL;
int js_buf_len = 1024;
int js_buf_len_data = 0;

char *js_buf2 = NULL;
int js_buf2_len = 1024;
int js_buf2_n = 0;

/* XStream */
xode_stream js;
xode_pool js_p;

/* Zmienne uzywane przez stream handlera */
char *sid;

int jabber_loged;

int jabber_send(const char *buf) {
	int n;
	my_debug(2, "jabber: wysylam '%s'", buf);
	if ((n = send(jabber_gniazdo, buf, strlen(buf), 0)) < 0) {
		my_debug(0, "jabber: send() failed");
		exit(1);
		return -1;
	} else {
		my_debug(5, "jabber: Wyslane");
	}
	return 0;
}

int jabber_recv(char **buf) {
	char *buffor = *buf;
	int n;
/*	while (1) { */
		if ((n = recv(jabber_gniazdo, buffor, 1024, 0)) < 0) {
			my_debug(0, "recv() failed");
			return -1;
/*			break;
		} else {
			if (n == 0)
				break;
			buffor[n] = 0;
		}
*/	}
	buffor[n] = 0;
	return 0;
}

int jabber_mypresence() {
	tt_user **user, *user0;
	/* Robimy sie dostepni */
	for (user = tt_users; *user; user++) {
		user0 = *user;
		if (user0->tlen_loged) {
			jabber_sndpresence(config_myfulljid, user0->jid, NULL, user0->jabber_status_type, user0->jabber_status);
		}
	}
	return 0;
}

int jabber_sendprobes() {
	tt_user **user, *user0;

	for (user = tt_users; *user; user++) {
		user0 = *user;
		jabber_sndpresence(config_myfulljid, user0->jid, "probe", NULL, NULL);
	}
	return 0;
}

int jabber_handler() {
	jabber_recv(&js_buf);
	my_debug(2, "jabber: Obsluga zdazen");
	my_debug(5, "jabber: Zawartosc buffora: %s", js_buf);
	xode_stream_eat(js, js_buf, -1);
	return 0;
}

int status_jabber_to_tlen(const char *show) {
	int tlen_type;
	if (show == NULL) {
		tlen_type = 2;
	} else if (strcmp(show, "") == 0) {
		tlen_type = 2;
	} else if (strcmp(show, "away") == 0) {
		tlen_type = 4;
	} else if (strcmp(show, "xa") == 0) {
		tlen_type = 3;
	} else if (strcmp(show, "dnd") == 0) {
		tlen_type = 5;
	} else if (strcmp(show, "chat") == 0) {
		tlen_type = 6;
	} else  {
		tlen_type = 2;
		my_debug(0, "FIXIT: Bladu typu statusu");
	}
	return tlen_type;
}

void jabber_stream_handler(int typ, xode x, void *arg) {
	char *to = NULL, *from = NULL, *body = NULL, *type = NULL, *id = NULL;
	char *to0 = NULL, *to1 = NULL, *from0 = NULL;
	int retval;
	xode temp, y;
	tt_user **user, *user0;
	tx_user **item, *item0;

	char *mytag = NULL;
	char *temp1 = NULL;
	
	mytag = xode_get_name(x);

	if (strcmp(mytag, "handshake") == 0) {
		jabber_loged = 1;
		my_debug(2, "jabber: zdazenie handshake");
	} else if (strcmp(mytag, "stream:stream") == 0) {
		my_debug(2, "jabber: zdazenie stream:stream");
		if ((temp1 = xode_get_attrib(x, "id")) == NULL) {
			my_debug(0, "jabber: Blad w atrybucie id (wymagany)");
			exit(1);
		}
		my_strcpy(sid, temp1);
	} else if (strcmp(mytag, "message") == 0) {
		int tlen_type;

		my_debug(2, "jabber: zdazenie message");

		if ((to = xode_get_attrib(x, "to")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie to (wymagany)");
			return;
		}
		if ((from = xode_get_attrib(x, "from")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie from (wymagany)");
			return;
		}
		if ((type = xode_get_attrib(x, "type")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie type (opcjonalny)");
		}

        /*
<message type="chat" id="sd31" to="tlen@user" from="jabber@user">
<body>.</body>
<html xmlns="http://jabber.org/protocol/xhtml-im">
    <body xmlns="http://www.w3.org/1999/xhtml">
        <span style="font-weight: normal; font-size: 9pt; color: #004200; font-style: normal; font-family: arial">.</span>
    </body>
</html>
<x xmlns="jisp:x:jep-0038"><name>wpk</name></x>
<active xmlns="http://jabber.org/protocol/chatstates"/>
</message>

<message to="jabber@user">
    <x xmlns="jabber:x:event"><composing/><id></id></x>
</message>

<message to="jabber@user">
    <x xmlns="jabber:x:event"><id></id></x>
</message>

<message type="chat" id="sd36" to="kg@jabberpl.org/Psi" from="kg@jabber.autocom.pl/Pandion">
<body>.</body>
<html xmlns="http://jabber.org/protocol/xhtml-im">
    <body xmlns="http://www.w3.org/1999/xhtml">
        <span style="font-weight: normal; font-size: 9pt; color: #004200; font-style: normal; font-family: arial">.</span>
    </body>
</html>
<x xmlns="jisp:x:jep-0038"><name>wpk</name></x>
<x xmlns="jabber:x:event"><composing/></x>
</message>

        */
		if ((temp = xode_get_tag(x, "body")) == NULL) {
			my_debug(5, "jabber: Blad w tagu body (opcjonalny, zalecany)");
		} else {
			if ((temp1 = xode_get_data(temp)) == NULL) {
				my_debug(5, "jabber: Blad w danych body");
				return;
			} else {
				if ((body = unicode_utf8_2_iso88592((const char *)temp1)) == NULL) {
					my_debug(5, "jabber: Blad w konwersji body");
					return;
				}
			}
		}

		if (type == NULL) {
			tlen_type = TLEN_MESSAGE;
		} else if (strcmp(type, "message") == 0)  {
			tlen_type = TLEN_MESSAGE;
		} else if (strcmp(type, "chat") == 0) {
			tlen_type = TLEN_CHAT;
		} else  {
			tlen_type = TLEN_CHAT;
			my_debug(0, "FIXIT: Blad typu");
		}

		from0 = jid_jidr2jid(from);
		user = jid_jid2user(from0);
		t_free(from0);

		if (user) {
			if (*user) {
				user0 = *user;
				to0 = jid_jidr2jid(to);

				if (user0->tlen_sesja && user0->tlen_loged == 2) {
					to0 = jid_jidr2jid(to);
					if (strcmp(to0, config_myjid) == 0 || strcmp(to0, config_myfulljid) == 0) {
						if (strcmp(body, "gr") == 0) {
							jabber_sndmessage(to0, from, "chat", NULL, "Importowanie rostra:", NULL);
							for (item = user0->roster; *item; item++) {
								item0 = *item;
								temp1 = jid_tid2jid(item0->tid);
								jabber_sndmessage(to0, from, "chat", NULL, temp1, NULL);
								jabber_sndpresence(temp1, user0->jid, "subscribed", NULL, NULL);
								jabber_sndpresence(temp1, user0->jid, "subscribe", NULL, NULL);
								t_free(temp1);
							}
							jabber_sndmessage(to0, from, "chat", NULL, "Koniec importu.", NULL);
						} else if (strcmp(body, "gp") == 0) {
							char *temp;
							temp = malloc(1024);
							strcpy(temp, "Twoje haslo tlena to: ");
							strcat(temp, user0->password);
							jabber_sndmessage(to0, from, "chat", NULL, temp, NULL);
							t_free(temp);
						} else if (strcmp(body, "sr") == 0) {
							char *temp;
							temp = malloc(10240);
							strcpy(temp, "\nWyswietlanie rostra:\n");
							for (item = user0->roster; *item; item++) {
								item0 = *item;
								temp1 = jid_tid2jid(item0->tid);
								strcat(temp, temp1);
								strcat(temp, "\n");
								t_free(temp1);
							}
							strcat(temp, "Koniec rostra.");
							jabber_sndmessage(to0, from, "chat", NULL, temp, NULL);
							t_free(temp);
						} else if (strcmp(body, "lm") == 0) {
						} else if (strcmp(body, "sm") == 0) {
							if (user0->mailnotify == 1)
								user0->mailnotify = 0;
							else if (user0->mailnotify == 0)
								user0->mailnotify = 1;
							users_save(user0->jid);
						} else if (strcmp(body, "sn") == 0) {
							if (user0->typingnotify == 1)
								user0->typingnotify = 0;
							else if (user0->typingnotify == 0)
								user0->typingnotify = 1;
							users_save(user0->jid);
						} else if (strcmp(body, "tt") == 0) {
							char *temp;
							temp = malloc(1024);
							snprintf(temp, 1023, "\nZarejstrowanych uzytkownikow: %d\n"
									"Zalogowanych uzytkownikow: %d", 0, 0);
							jabber_sndmessage(to0, from, "chat", NULL, temp, NULL);
							t_free(temp);
						} else if (strcmp(body, "cp") == 0) {
						} else {
							char *temp;
							char *tf;
							int n;
							tf = "\nDostepne komendy:\n"
									"gr - Wczytuje roster tlenowy do jabbera (POPSUTE)\n"
									"gp - Wyswietla haslo tlenowe\n"
									"sr - Wyswietla roster tlena\n"
									"lm - Loguje sie na serwer pocztowy i wyswietla spis poczty (NIEZAIMPLEMENTOWANE)\n"
									"sn - Wlacza/Wylacza powiadamianie u pisaniu\n"
									"sm - Wlacza/Wylacza powiadamianie o poczcie w tlen.pl\n"
									"tt - Informacje administracyjne (NIEZAIMPLEMENTOWANE)\n"
									"cp - Zmien haslo (NIEZAIMPLEMENTOWANE)\n\n"
									"Jestes zarejstrowany jako: %s\n\n"
									"Powiadamianie o poczcie: %s\n"
									"Powiadamianie o pisaniu: %s\n\n"
									"W razie problemow prosze pisac do JID: movax@jabber.mpi.int.pl";
							n = strlen(tf) + strlen(user0->tid_short) +
							    strlen((user0->mailnotify ? "Wlaczone" : "Wylaczone")) +
							    strlen((user0->typingnotify ? "Wlaczone" : "Wylaczone")) + 1;
							temp = malloc(n);
							snprintf(temp, n, tf,
									user0->tid_short,
									(user0->mailnotify ? "Wlaczone" : "Wylaczone"),
									(user0->typingnotify ? "Wlaczone" : "Wylaczone"));
							jabber_sndmessage(to0, from, "chat", NULL, temp, NULL);
							t_free(temp);
						}
					} else {
						int notify;
						notify = 0;
						to1 = jid_jid2tid(to0);
    						/* zrobic obluge <html xmlns='http://jabber.org/protocol/xhtml-im'><body xmlns='http://www.w3.org/1999/xhtml'>...</body></html> */
						if ((temp = xode_get_tag(x, "x")) == NULL) {
							my_debug(5, "jabber: Brak tagu x (opcjonalny)");
							notify = 0;
						} else {
							if ((temp1 = xode_get_attrib(temp, "xmlns")) == NULL) {
								my_debug(5, "jabber: Brak atrybutu xmlns");
								notify = 0;
							} else {
								 /* FIXIT: DOKONCZYC */
								if ((strcmp(temp1, "jabber:x:event") != 0)) {
									my_debug(5, "jabber: Nieznany xmlns");
									notify = 0;
								} else {
									if ((temp = xode_get_tag(temp, "composing")) == NULL) {
										notify = 2;
									} else {
										notify = 1;
									}
								}
							}
						}

						switch (notify) {
							case 0:
								tlen_sendmsg(user0->tlen_sesja, to1, body, tlen_type);
								break;
							case 1:
								if (body) {
									tlen_sendmsg(user0->tlen_sesja, to1, body, tlen_type);
								} else {
									tlen_sendnotify(user0->tlen_sesja, to1, TLEN_NOTIFY_TYPING);
								}
								break;
							case 2:
								tlen_sendnotify(user0->tlen_sesja, to1, TLEN_NOTIFY_NOTTYPING);
								break;
							case 3: /* jakis blad xml ? */
								break;
						}
						t_free(to1);
					}
					t_free(to0)
				} else {
					jabber_sndmessage(config_myfulljid, from, "error", NULL, "Nie jestes zalogowany", NULL);
				}
			}
		} else {
			my_debug(0, "jabber: User nie jest zarejstrowanym uzytkownikiem");
			jabber_sndmessage(config_myjid, from, "error", NULL, "Nie jestes zarejstrowany", NULL);
		}
		t_free(body);
	} else if (strcmp(mytag, "presence") == 0) {
		char *show = NULL, *status = NULL, *status_iso = NULL;
		int tlen_type = 0;

		my_debug(3, "jabber: zdazenie presence");

		if ((to = xode_get_attrib(x, "to")) == NULL) {
			my_debug(4, "jabber: Brak atrybutu to (wymagany");
			return;
		}
		if ((from = xode_get_attrib(x, "from")) == NULL) {
			my_debug(4, "jabber: Brak atrybutu from (wymagany)");
			return;
		}
		if ((type = xode_get_attrib(x, "type")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie type (opcjonalny)");
		}

		if ((temp = xode_get_tag(x, "show")) == NULL) {
			my_debug(5, "jabber: Brak tagu show (opcjonalny)");
		} else {
			if ((show = xode_get_data(temp)) == NULL) {
				my_debug(5, "jabber: Blad w danych show");
				return;
			}
		}

		if ((temp = xode_get_tag(x, "status")) == NULL) {
			my_debug(5, "jabber: Brak tagu status (opcjonalny)");
		} else {
			if ((status = xode_get_data(temp)) == NULL) {
				my_debug(5, "jabber: Blad w danych status (opcjonalny)");
				return;
			} else {
				if ((status_iso = unicode_utf8d_2_iso88592e((const char *)status)) == NULL) {
					my_debug(5, "jabber: Blad w konwersji status");
					return;
				}
			}
		}

		my_debug(2, "jabber: Otrzymalem info o statusie '%s' do '%s' (type=%s, show=%s, status=%s)", from, to, type, show, status);

		from0 = jid_jidr2jid(from);
		user = jid_jid2user(from0);
		t_free(from0);

		if (user) {
			user0 = *user;
			if (user0) {
				if (strcmp(to, config_myjid) == 0 || strcmp(to, config_myfulljid) == 0) {
					if (type != NULL) {
					    	if (strcmp(type, "unavailable") == 0) {
							if (user0->tlen_loged == 2) {
								my_debug(2, "jabber: Wylogowywanie usera: %s, o jid: %s", user0->tid, user0->jid);
								tlen_logout_user(user0, status_iso);
							} else {
								jabber_sndpresence(config_myfulljid, user0->jid, "unavailable", NULL, NULL);
							}
						}
					} else {
						user0->status_type = status_jabber_to_tlen(show);
						my_strcpy(user0->status, status_iso); /* FIXIT, sprawdzic pamiec */
						my_strcpy(user0->jabber_status, status);
						my_strcpy(user0->jabber_status_type, show);
						if (user0->tlen_loged == 0) {
							my_debug(2, "jabber: Tworze polaczenie z serwerem Tlen.pl dla usera: %s, o jid: %s", user0->tid, user0->jid);
							tlen_login_user(user0);
						} else if (user0->tlen_loged == 2) { /* FIXIT */
							my_debug(2, "k");
							tlen_presence_user(user0);
						}
					}
				} else {
					if (type == NULL || strcmp(type, "") == 0) {
						user0->status_type = status_jabber_to_tlen(show);;
						my_strcpy(user0->status, status_iso); /* FIXIT, sprawdzic pamiec */
						my_strcpy(user0->jabber_status, status);
						my_strcpy(user0->jabber_status_type, show);
						if (user0->tlen_loged == 0) {
							my_debug(2, "jabber: Tworze polaczenie z serwerem Tlen.pl dla usera: %s, o jid: %s", user0->tid, user0->jid);
							tlen_login_user(user0);
						} else {
							my_debug(2, "g");
							tlen_presence_user(user0);
						}
	    				} else if (strcmp(type, "unavailable") == 0) {
						tlen_type = 8;
						if (user0->tlen_loged == 2) {
							tlen_logout_user(user0, NULL); /* status */
						}
					} else if (strcmp(type, "subscribe") == 0) {
						to0 = jid_jid2tid(to);
						my_debug(3, "jabber: Wysylam request subscribe do %s", to0);
						if (user0->tlen_loged == 2) {
							tlen_request_subscribe(user0->tlen_sesja, to0);
						}
						t_free(to0);
					} else if (strcmp(type, "subscribed") == 0) {
						to0 = jid_jid2tid(to);
						my_debug(3, "jabber: Wysylam accept subscribe do %s", to0);
						if (user0->tlen_loged == 2) {
							tlen_accept_subscribe(user0->tlen_sesja, to0);
						}
						t_free(to0);
					} else if (strcmp(type, "unsubscribe") == 0) {
						to0 = jid_jid2tid(to);
						my_debug(3, "jabber: Wysylam request unsubscribe do %s", to0);
						if (user0->tlen_loged == 2) {
							tlen_request_unsubscribe(user0->tlen_sesja, to0);
						}
						t_free(to0);
					} else if (strcmp(type, "unsubscribed") == 0) {
						to0 = jid_jid2tid(to);
						my_debug(3, "jabber: Wysylam accept unsubscribe do %s", to0);
						if (user0->tlen_loged == 2) {
							tlen_accept_unsubscribe(user0->tlen_sesja, to0);
							tlen_removecontact(user0->tlen_sesja, to0);
						}
						t_free(to0);
					} else if (strcmp(type, "probe") == 0) {
						to0 = jid_jid2tid(to);
						my_debug(3, "jabber: Sprawdzam status %s", to0);
						/* FIXIT */
						t_free(to0);
					}
				}
			}
		} else {
			my_debug(0, "jabber: User nie jest zarejstrowanym uzytkownikiem");
			jabber_sndmessage(config_myjid, from, "error", NULL, "Nie jestes zarejstrowany", NULL);
		}
		t_free(status_iso);
	} else if (strcmp(mytag, "iq") == 0) {
    		my_debug(3, "jabber: zdazenie iq");

		if ((id = xode_get_attrib(x, "id")) == NULL) {
			/* Jak sie okazuje id nie jest wymagany */
			my_debug(5, "jabber: Blad w atrybucie id (wymagany(?))");
			/*return;*/
		}
		if ((from = xode_get_attrib(x, "from")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie from (wymagany)");
			return;
		}
		if ((type = xode_get_attrib(x, "type")) == NULL) {
			my_debug(5, "jabber: Blad w atrybucie type (wymagany)");
			return;
		}

		if (strcmp(type, "get") == 0) {
			if ((y = xode_get_tag(x, "query")) == NULL) {
				my_debug(5, "jabber: Blad w tagu query");
				if ((y = xode_get_tag(x, "vCard")) == NULL) {
					my_debug(5, "jabber: Blad w tagu vCard");
					return;
				}
				from0 = jid_jidr2jid(from);
				user = jid_jid2user(from0);
				t_free(from0);
				if (user) {
					user0 = *user;
					if (user0) {
						if (user0->tlen_loged == 2) {
							struct tlen_pubdir *search;
							my_strcpy(user0->search_id, "vCardsearch");
							my_strcpy(user0->search_jid, from);
							if ((body = xode_get_attrib(y, "xmlns")) == NULL) {
								my_debug(5, "jabber: Blad w atrybucie xmlns");
								return;
							}
							if (strcmp(body, "vcard-temp") != 0) {
								my_debug(5, "jabber: Blad w atrybucie xmlns2");
								return;
							}
							if ((to = xode_get_attrib(x, "to")) == NULL) {
								my_debug(5, "jabber: Blad w atrybucie to");
								return;
							}
							to0 = jid_jidr2jid(to);
							to1 = jid_jid2tid(to0);


							search = tlen_new_pubdir();
							search->id = to1;
							tlen_search(user0->tlen_sesja, search);
							tlen_free_pubdir(search);
							t_free(to0);
						}
					}
				}
			} else {
				if ((body = xode_get_attrib(y, "xmlns")) == NULL) {
					my_debug(5, "jabber: Blad w atrybucie xmlns (wymagany)");
					return;
				}

				if (strcmp(body, "jabber:iq:register") == 0) {
					jabber_sndregister_form(id, from);
				} else if (strcmp(body, "jabber:iq:version") == 0) {
					if ((to = xode_get_attrib(x, "to")) == NULL) {
						my_debug(4, "Blad w atrybucie to (wymagany)");
						return;
					}
					to0 = jid_jid2tid(to);
					jabber_sndversion_result(id, to, from);
				} else if (strcmp(body, "jabber:iq:gateway") == 0) {
					jabber_sndgate_form(id, from);
				} else if (strcmp(body, "jabber:iq:search") == 0) {
					from0 = jid_jidr2jid(from);
					user = jid_jid2user(from0);
					t_free(from0);
					if (user) {
						user0 = *user;
						if (user0) {
							if (user0->tlen_loged == 2) {
								jabber_sndsearch_form(id, from);
							} else {
							    	jabber_sndiq(config_myfulljid, from, "error", id, "<error code='409'>Not loged</error>");
							}
						}
					} else {
						my_debug(0, "jabber: User nie jest zarejstrowanym uzytkownikiem");
						jabber_sndiq(config_myjid, from, "error", id, "<error code='409'>Not registred</error>");
					}
				} else if (strcmp(body, "http://jabber.org/protocol/disco#info") == 0) {
					jabber_snddisco(id, from);
				} else {
					my_debug(3, "jabber: Nie znane zapytanie iq!");
				}
			}
		} else if  (strcmp(type, "set") == 0) {
			if ((y = xode_get_tag(x, "query")) == NULL) {
				my_debug(3, "jabber: Blad w tagu query (wymagany)");
				return;
			} else {
			if ((body = xode_get_attrib(y, "xmlns")) == NULL) {
				my_debug(3, "jabber: Blad w atrybucie xmlns (wymagany)");
				return;
			}

			if (strcmp(body, "jabber:iq:register") == 0) {
				char *username, *password;
				/*
				<iq id='reg2' type='set'><query xmlns='jabber:iq:register'>
				<username>tlenuser</username>
				<password>secret</password>
				</query></iq>
				*/
				if ((temp = xode_get_tag(y, "remove")) != NULL) {
					my_debug(5, "jabber: Tag remove");
					retval = jabber_unregister(from);
					switch (retval) {
						case 0:
							jabber_sndiq(config_myjid, from, "result", id, NULL);
							break;
						case 1:
							jabber_sndiq(config_myjid, from, "error", id, "<error code='406'>Not registred</error>");
							break;
					}
				} else {
					my_debug(5, "jabber: Blad w tagu remove (alternatywny)");
					if ((temp = xode_get_tag(y, "username")) == NULL) {
						my_debug(3, "jabber: Blad w tagu username (wymagany)");
						return;
					}
					username = xode_get_data(temp);
					if ((temp = xode_get_tag(y, "password")) == NULL) {
						my_debug(3, "jabber: Blad w tagu password (wymagany)");
						return;
					}
					password = xode_get_data(temp);
					if (username != NULL && password != NULL && strlen(username) > 0) {
						retval = jabber_register(from, username, password);
						switch (retval) {
							case 0:
								jabber_sndiq(config_myjid, from, "result", id, NULL);
								jabber_sndpresence(config_myfulljid, from, "subscribed", NULL, NULL);
								jabber_sndpresence(config_myfulljid, from, "subscribe", NULL, NULL);
								break;
							case 1:
								jabber_sndiq(config_myfulljid, from, "error", id, "<error code='409'>Already registred</error>");
								break;
							case 3:
								jabber_sndiq(config_myfulljid, from, "error", id, "<error code='401'>Nothauthorized</error>");
								break;
							case 2:
								jabber_sndiq(config_myfulljid, from, "error", id, "<error code='409'>Username Not Avaible</error>");
								break;
							case 4:
								break;
								/* <error code='500'>Password Storage Failed</error></iq> */
						}
					} else if ((username != NULL && password != NULL && strlen(username) == 0 && strlen(password) == 0) || (username == NULL && password == NULL)) {
						retval = jabber_unregister(from);
						switch (retval) {
							case 0:
								jabber_sndiq(config_myjid, from, "result", id, NULL);
								break;
							case 1:
								jabber_sndiq(config_myjid, from, "error", id, "<error code='406'>Not registred</error>");
								break;
						}
					} else {
						my_debug(3, "jabber: Bledny tid lub/i haslo w czasie rejstracji");
						jabber_sndiq(config_myjid, from, "error", id, "<error code='406'>Bad syntax of username and/or password</error>");
					}
				}
			} else if (strcmp(body, "jabber:iq:gateway") == 0) {
				char *prompt;
				/*
				<iq type="set" to="tlen.jabber.mpi.int.pl" id="reg"><query xmlns="jabber:iq:gateway">
				<prompt>asdfa</prompt>
				</query></iq>
				*/
				if ((temp = xode_get_tag(y, "prompt")) == NULL) {
					my_debug(3, "jabber: Blad w tagu prompt");
				}
				if ((prompt = xode_get_data(temp)) == NULL) {
					my_debug(3, "jabber: Blad w danych prompt");
				}
				if (prompt != NULL && strlen(prompt) > 0) {
					jabber_sndgate_result(id, from, prompt);
				}
				/* jabber_sndiq(config_myjid, from, "error", id, "<error code='406'>Bad syntax of username</error>");
				*/
			} else if (strcmp(body, "jabber:iq:search") == 0) {
				xode z, z1, z2;
				my_debug(3, "jabber: Wyszukiwanie...");
				from0 = jid_jidr2jid(from);
				user = jid_jid2user(from0);
				t_free(from0);
				if (user) {
					user0 = *user;
					if (user0) {
						if (user0->tlen_loged == 2) {
							struct tlen_pubdir *search;
							my_strcpy(user0->search_id, id);
							my_strcpy(user0->search_jid, from);
							search = tlen_new_pubdir();
							if ((z = xode_get_tag(y, "x?xmlns=jabber:x:data")) != NULL) {
								my_debug(4, "Dane przekazane przez x");
								if ((temp1 = xode_get_attrib(z, "type")) == NULL) {
									my_debug(4, "Brak type");
								} else {
									if (strcmp(temp1, "submit") != 0) {
										my_debug(4, "Nie znany typ");
									} else {
										if ((z1 = xode_get_tag(z, "field?var=tid")) != NULL) {
											if ((z2 = xode_get_tag(z1, "value")) != NULL) {
												temp1 = xode_get_data(z2);
												search->id = unicode_utf8d_2_iso88592e(temp1);
											}
										}
										if ((z1 = xode_get_tag(z, "field?var=nick")) != NULL) {
											if ((z2 = xode_get_tag(z1, "value")) != NULL) {
												temp1 = xode_get_data(z2);
												search->nick = unicode_utf8d_2_iso88592e(temp1);
											}
										}
										if ((z1 = xode_get_tag(z, "field?var=firstname")) != NULL) {
											if ((z2 = xode_get_tag(z1, "value")) != NULL) {
												temp1 = xode_get_data(z2);
												search->firstname = unicode_utf8d_2_iso88592e(temp1);
											}
										}
										if ((z1 = xode_get_tag(z, "field?var=lastname")) != NULL) {
											if ((z2 = xode_get_tag(z1, "value")) != NULL) {
												temp1 = xode_get_data(z2);
												search->lastname = unicode_utf8d_2_iso88592e(temp1);
											}
										}
										if ((z1 = xode_get_tag(z, "field?var=city")) != NULL) {
											if ((z2 = xode_get_tag(z1, "value")) != NULL) {
												temp1 = xode_get_data(z2);
												search->city = unicode_utf8d_2_iso88592e(temp1);
											}
										}
										tlen_search(user0->tlen_sesja, search);
										tlen_free_pubdir(search);
									}
								}
							} else {
								my_debug(4, "Dane przekazane przez tagi");
								if ((temp = xode_get_tag(y, "city")) == NULL) {
									my_debug(5, "jabber: Blad w tagu city (opcjonalny)");
								} else {
									temp1 = xode_get_data(temp);
									search->city = unicode_utf8d_2_iso88592e(temp1);
								}

								if ((temp = xode_get_tag(y, "first")) == NULL) {
									my_debug(5, "jabber: Blad w tagu first (opcjonalny)");
								} else {
									temp1 = xode_get_data(temp);
									search->firstname = unicode_utf8d_2_iso88592e(temp1);
								}

								if ((temp = xode_get_tag(y, "last")) == NULL) {
									my_debug(5, "jabber: Blad w tagu last (opcjonalny)");
								} else {
									temp1 = xode_get_data(temp);
									search->lastname = unicode_utf8d_2_iso88592e(temp1);
								}

								if ((temp = xode_get_tag(y, "nick")) == NULL) {
									my_debug(5, "jabber: Blad w tagu nick (opcjonalny)");
								} else {
									temp1 = xode_get_data(temp);
									search->nick = unicode_utf8d_2_iso88592e(temp1);
								}

								/* sprawdzic czy sa jakies pola */

								tlen_search(user0->tlen_sesja, search);
								tlen_free_pubdir(search);
							}
						} else {
							jabber_sndiq(config_myfulljid, from, "error", id, "<error code='409'>Not loged</error>");
						}
					}
				} else {
					my_debug(0, "jabber: Nie zarejstrowany");
					jabber_sndiq(config_myjid, from, "error", id, "<error code='409'>Not registred</error>");
				}
			} else {
				my_debug(3, "jabber: Nie znane polecenie iq!");
			}
			}
		}
	} else if (strcmp(mytag, "error") == 0) {
		my_debug(1, "jabber: zdazenie error");
		exit(1);
	} else if (strcmp(mytag, "stream:error") == 0) {
		my_debug(1, "jabber: blad stream");
		exit(1);
	}
	xode_free(x);
}

/* JEP-0114 */

int jabber_ping() {
	return 0;
}
